# Community projects

Projects built by community members:

* The [SHARK](https://github.com/nod-ai/SHARK) project offers user interfaces
  for running a large corpus of machine learning programs.

* The [sharktank](https://github.com/nod-ai/sharktank) project contains
  modeling and serving libraries for popular genai applications.

* The [SHARK-Turbine](https://github.com/nod-ai/SHARK-Turbine) project is an
  integration repository for various model bringup activities. Several parts
  of SHARK-Turbine graduated to
  [iree-turbine](https://github.com/iree-org/iree-turbine) and
  [sharktank](https://github.com/nod-ai/sharktank).

* The [IREE C++ Template](https://github.com/iml130/iree-template-cpp) *(archived)*
  showed one way to integrate IREE's runtime into a project with CMake.

Official repositories:

* [iree-turbine](https://github.com/iree-org/iree-turbine) is home to IREE's
  [PyTorch](https://pytorch.org/) frontend.

* [iree-jax](https://github.com/iree-org/iree-jax) is home to
  IREE's AOT support for [JAX](https://github.com/google/jax) programs.

* [iree-experimental](https://github.com/iree-org/iree-experimental)
  includes various samples and prototypes built with IREE.

* [iree-llvm-sandbox](https://github.com/iree-org/iree-llvm-sandbox)
  contains experimental work by the IREE team closely related to LLVM and
  MLIR, usually with the aim of contributing back to those upstream projects.

* [iree-org/iree-bare-metal-arm](https://github.com/iree-org/iree-bare-metal-arm)
  contains a various samples that demonstrate how to build IREE with the
  [Arm GNU Toolchain](https://developer.arm.com/tools-and-software/open-source-software/developer-tools/gnu-toolchain)
  for bare-metal Arm targets using the open-source firmware libraries
  [CMSIS](https://github.com/ARM-software/CMSIS_5) and
  [libopencm3](https://github.com/libopencm3/libopencm3).
